using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Common.Shared.Net {
	/// <summary>
	/// 
	/// </summary>
	public class FtpDownloadEventArgs : EventArgs {

		/// <summary>
		/// Initializes a new instance of the <see cref="FtpDownloadEventArgs"/> class.
		/// </summary>
		/// <param name="remote">The remote.</param>
		/// <param name="local">The local.</param>
		public FtpDownloadEventArgs ( Uri remote, FileInfo local ) {
			this.LocalFile = local;
			this.RemoteFile = remote;
		}

		private FileInfo _local;
		private Uri _remote;

		/// <summary>
		/// Gets or sets the remote file.
		/// </summary>
		/// <value>The remote file.</value>
		public Uri RemoteFile {
			get { return _remote; }
			private set { _remote = value; }
		}

		/// <summary>
		/// Gets or sets the local file.
		/// </summary>
		/// <value>The local file.</value>
		public FileInfo LocalFile {
			get { return _local; }
			private set { _local = value; }
		}

	}
}
