using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using Common.Shared.Design;

namespace Common.Shared.Xml.Wddx {
	[WddxRoot ( "header" )]
	public class WddxHeader : WddxObject {
		private WddxHeaderComment _comment;

		/// <summary>
		/// Initializes a new instance of the <see cref="WddxHeader"/> class.
		/// </summary>
		public WddxHeader ( )
			: this ( string.Empty ) {

		}

		/// <summary>
		/// Initializes a new instance of the <see cref="WddxHeader"/> class.
		/// </summary>
		/// <param name="comment">The comment.</param>
		public WddxHeader ( string comment ) {
			this.Comment = new WddxHeaderComment ( comment );
		}

		/// <summary>
		/// Gets or sets the comment.
		/// </summary>
		/// <value>The comment.</value>
		[WddxElement ( "comment" )]
		public WddxHeaderComment Comment {
			get { return _comment; }
			set { _comment = value; }
		}

	}
}
